
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>Regular LSTMs &#8212; Battery SOH 2022 documentation</title>
    
  <link href="_static/css/theme.css" rel="stylesheet" />
  <link href="_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="_static/basic.css" />
    
  <link rel="preload" as="script" href="_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="./" id="documentation_options" src="_static/documentation_options.js"></script>
    <script src="_static/jquery.js"></script>
    <script src="_static/underscore.js"></script>
    <script src="_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="index.html">
  <img src="_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
              
              <div class="toc-item">
                
<div class="tocsection onthispage pt-5 pb-3">
    <i class="fas fa-list"></i> On this page
</div>

<nav id="bd-toc-nav">
    <ul class="visible nav section-nav flex-column">
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#models">
   Models
  </a>
 </li>
 <li class="toc-h2 nav-item toc-entry">
  <a class="reference internal nav-link" href="#dataset-class">
   Dataset class
  </a>
 </li>
</ul>

</nav>
              </div>
              
              <div class="toc-item">
                
              </div>
              
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <div class="section" id="regular-lstms">
<h1>Regular LSTMs<a class="headerlink" href="#regular-lstms" title="Permalink to this headline">¶</a></h1>
<div class="section" id="models">
<span id="normal-lstm-models"></span><h2>Models<a class="headerlink" href="#models" title="Permalink to this headline">¶</a></h2>
<dl class="py class">
<dt class="sig sig-object py" id="LSTM.LSTM_v1">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM.</span></span><span class="sig-name descname"><span class="pre">LSTM_v1</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">delta</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">hidden_dim</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">pooling_layer</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'bi_mean'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">drop_out</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">version</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_layers</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_dropout</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/LSTM.html#LSTM_v1"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM.LSTM_v1" title="Permalink to this definition">¶</a></dt>
<dd><p>LSTM type neural net for Battery SOH estimation.</p>
<p>This class is part of the “regular” LSTMs, or the “normal” <code class="docutils literal notranslate"><span class="pre">variant</span></code>.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This class is made for versions 1-3, for versions 4-5 check
<a class="reference internal" href="#LSTM.LSTM_v4" title="LSTM.LSTM_v4"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v4</span></code></a>.</p>
</div>
<p>Version 1 takes <code class="docutils literal notranslate"><span class="pre">delta</span></code> current points and the correponding <code class="docutils literal notranslate"><span class="pre">delta</span></code>
voltage points per <img class="math" src="_images/math/c67734af70861b2bd4dedf5c41c9aad231466f84.png" alt="x_i"/>. Its number of features is thus <code class="docutils literal notranslate"><span class="pre">2*delta</span></code>.</p>
<p>Version 2 takes <code class="docutils literal notranslate"><span class="pre">delta</span></code> current, voltage and temperature points per
<img class="math" src="_images/math/c67734af70861b2bd4dedf5c41c9aad231466f84.png" alt="x_i"/>. The temperature points are temperature measurements done during
battery cycling and may not be available for all datasets.
Its number of features is thus <code class="docutils literal notranslate"><span class="pre">3*delta</span></code>.</p>
<p>Version 3 takes <code class="docutils literal notranslate"><span class="pre">delta</span></code> current and voltage points, plus the ambient
temperature per <img class="math" src="_images/math/c67734af70861b2bd4dedf5c41c9aad231466f84.png" alt="x_i"/>. Its number of features is thus <code class="docutils literal notranslate"><span class="pre">2*delta+1</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>delta</strong> (<em>int</em>) – The size of the sliding window used to generate the <img class="math" src="_images/math/c67734af70861b2bd4dedf5c41c9aad231466f84.png" alt="x_i"/> s.</p></li>
<li><p><strong>hidden_dim</strong> (<em>int</em>) – Hidden dimension of the LSTM (also its main output dimension).</p></li>
<li><p><strong>pooling_layer</strong> (<em>{'last'</em><em>, </em><em>'mean'</em><em>, </em><em>'bi_mean&quot;}</em><em>, </em><em>default = 'bi_mean'</em>) – <p>Decides the type of pooling layer:</p>
<ul>
<li><p><code class="docutils literal notranslate"><span class="pre">'last'</span></code> (only takes the last result),</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">'mean'</span></code> (takes the mean of the results) and</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">'bi_mean'</span></code> (takes the mean of the product).</p></li>
</ul>
<p>The default value is strongly recommended. It’s the one that’s had the
best results, in the article and in our tests.</p>
</p></li>
<li><p><strong>drop_out</strong> (<em>float</em><em>, </em><em>optional</em>) – The probability of the dropout layer that comes right after the LSTM.
Must be a number between 0 and 1.</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em><em>, </em><em>optional</em>) – <p>A tuple containing all of the information necessary for normalization.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This isn’t a necessary parameter and <strong>isn’t</strong> used in this model in
any way. Instead, it relies on recieving data previously normalized
by <a class="reference internal" href="#LSTM.Torch_Dataset_LSTM" title="LSTM.Torch_Dataset_LSTM"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.Torch_Dataset_LSTM</span></code></a> (for LSTMs that do normalization
check <a class="reference internal" href="LSTMwithNorm.html"><span class="doc">LSTMs with normalization</span></a>).</p>
<p>However, it’s useful to define a <code class="docutils literal notranslate"><span class="pre">norm</span></code> value (such as the
training dataset’s) for documentation purposes, it is very useful
when calling a saved model. It’s good practice.</p>
</div>
</p></li>
<li><p><strong>version</strong> (<em>int</em><em>, </em><em>default = 1</em>) – <p>The model version to be used.</p>
<ul>
<li><p><code class="docutils literal notranslate"><span class="pre">version</span> <span class="pre">=</span> <span class="pre">1</span></code> corresponds to the model created by the article cited.</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">version</span> <span class="pre">=</span> <span class="pre">2</span></code> corresponds to the same model, but adapted to take the
cycle’s temperature data as well.</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">version</span> <span class="pre">=</span> <span class="pre">3</span></code> is similar to version 1, but takes the ambient
temperature as an extra input.</p></li>
</ul>
</p></li>
<li><p><strong>lin_layers</strong> (<em>int</em><em>, </em><em>default = 1</em>) – The number of linear regression layers. As of now, cannot be greater
than two (<strong>any value different than 1 will set it to two</strong>).</p></li>
<li><p><strong>lin_dropout</strong> (<em>float</em><em>, </em><em>optional</em>) – The value for the dropout layer that comes after the first linear layer
in the regression step. Will only be taken into accouunt if
<code class="docutils literal notranslate"><span class="pre">lin_layers</span></code> &gt; 1.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>AssertionError</strong> – If the version in different than 1, 2 or 3;
    If an unsupported <code class="docutils literal notranslate"><span class="pre">pooling_layer</span></code> is informed.</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">torch.utils.data</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">delta</span> <span class="o">=</span> <span class="mi">10</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">hidden_dim</span> <span class="o">=</span> <span class="mi">20</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">version</span> <span class="o">=</span> <span class="mi">2</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">model</span> <span class="o">=</span> <span class="n">LSTM_v1</span><span class="p">(</span><span class="n">delta</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="p">,</span> <span class="n">pooling_layer</span><span class="o">=</span><span class="s1">&#39;last&#39;</span><span class="p">,</span> <span class="n">version</span><span class="o">=</span><span class="n">version</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">([</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">version</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">estimated_capacity</span> <span class="o">=</span> <span class="n">model</span><span class="p">(</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">inputs</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss_function</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">nn</span><span class="o">.</span><span class="n">MSELoss</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss</span> <span class="o">=</span> <span class="n">loss_function</span><span class="p">(</span><span class="n">estimated_capacity</span><span class="p">,</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">output</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="go">2.2862</span>
</pre></div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="LSTM.LSTM_v1.forward">
<span class="sig-name descname"><span class="pre">forward</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">inputs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/LSTM.html#LSTM_v1.forward"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM.LSTM_v1.forward" title="Permalink to this definition">¶</a></dt>
<dd><p>Defines the computation performed at every call.</p>
<p>Should be overridden by all subclasses.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Although the recipe for forward pass needs to be defined within
this function, one should call the <code class="xref py py-class docutils literal notranslate"><span class="pre">Module</span></code> instance afterwards
instead of this since the former takes care of running the
registered hooks while the latter silently ignores them.</p>
</div>
</dd></dl>

</dd></dl>

<dl class="py class">
<dt class="sig sig-object py" id="LSTM.LSTM_v4">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM.</span></span><span class="sig-name descname"><span class="pre">LSTM_v4</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">delta</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">hidden_dim</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">pooling_layer</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'bi_mean'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">drop_out</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">version</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">4</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_layers</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">lin_dropout</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/LSTM.html#LSTM_v4"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM.LSTM_v4" title="Permalink to this definition">¶</a></dt>
<dd><p>LSTM type neural net for Battery SOH estimation.</p>
<p>This class is part of the “regular” LSTMs, or the “normal” <code class="docutils literal notranslate"><span class="pre">variant</span></code>.</p>
<p>The difference between this class and <a class="reference internal" href="#LSTM.LSTM_v1" title="LSTM.LSTM_v1"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v1</span></code></a> is that it
always takes the ambient temperature as an input, but directly at the final
regression layers, instead of the LSTM layer.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This class is made for versions 4-5, for versions 1-3 check
<a class="reference internal" href="#LSTM.LSTM_v1" title="LSTM.LSTM_v1"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v1</span></code></a>.</p>
</div>
<p>Version 4 is analogous to version 1: it takes <code class="docutils literal notranslate"><span class="pre">delta</span></code> current and voltage
points per <img class="math" src="_images/math/c67734af70861b2bd4dedf5c41c9aad231466f84.png" alt="x_i"/>. Its number of features (of the LSTM) is thus
<code class="docutils literal notranslate"><span class="pre">2*delta</span></code> (its input size will always be one more of that, <code class="docutils literal notranslate"><span class="pre">2*delta+1</span></code>).</p>
<p>Version 5 is analogous to a version 2: it takes current, voltage and
temperature points per <img class="math" src="_images/math/c67734af70861b2bd4dedf5c41c9aad231466f84.png" alt="x_i"/>. The temperature points are temperature
measurements done during battery cycling and may not be available for all
datasets. Its number of features (LSTM) is thus <code class="docutils literal notranslate"><span class="pre">3*delta</span></code>.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>delta</strong> (<em>int</em>) – The size of the sliding window used to generate the <img class="math" src="_images/math/c67734af70861b2bd4dedf5c41c9aad231466f84.png" alt="x_i"/> s.</p></li>
<li><p><strong>hidden_dim</strong> (<em>int</em>) – Hidden dimension of the LSTM (also its main output dimension).</p></li>
<li><p><strong>pooling_layer</strong> (<em>{'last'</em><em>, </em><em>'mean'</em><em>, </em><em>'bi_mean&quot;}</em><em>, </em><em>default = 'bi_mean'</em>) – <p>Decides the type of pooling layer:</p>
<ul>
<li><p><code class="docutils literal notranslate"><span class="pre">'last'</span></code> (only takes the last result),</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">'mean'</span></code> (takes the mean of the results) and</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">'bi_mean'</span></code> (takes the mean of the product).</p></li>
</ul>
<p>The default value is strongly recommended. It’s the one that’s had the
best results, in the article and in our tests.</p>
</p></li>
<li><p><strong>drop_out</strong> (<em>float</em>) – The probability of the dropout layer that comes right after the LSTM.
Must be a number between 0 and 1.</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em><em>, </em><em>optional</em>) – <p>A tuple containing all of the information necessary for normalization.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This isn’t a necessary parameter and <strong>isn’t</strong> used in this model in
any way. Instead, it relies on recieving data previously normalized
by <a class="reference internal" href="#LSTM.Torch_Dataset_LSTM" title="LSTM.Torch_Dataset_LSTM"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.Torch_Dataset_LSTM</span></code></a> (for LSTMs that do normalization
check <a class="reference internal" href="LSTMwithNorm.html"><span class="doc">LSTMs with normalization</span></a>).</p>
<p>However, it’s useful to define a <code class="docutils literal notranslate"><span class="pre">norm</span></code> value (such as the
training dataset’s) for documentation purposes, it is very useful
when calling a saved model. It’s good practice.</p>
</div>
</p></li>
<li><p><strong>version</strong> (<em>int</em><em>, </em><em>default = 4</em>) – <p>The model version to be used.
It will take the ambient temperature
as an input directly into the linear layers.</p>
<ul>
<li><p><code class="docutils literal notranslate"><span class="pre">version</span></code> = 4 is analogous to an <a class="reference internal" href="#LSTM.LSTM_v1" title="LSTM.LSTM_v1"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v1</span></code></a>’s version 1</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">version</span></code> = 5 is analogous to an <a class="reference internal" href="#LSTM.LSTM_v1" title="LSTM.LSTM_v1"><code class="xref py py-class docutils literal notranslate"><span class="pre">LSTM.LSTM_v1</span></code></a>’s version 2.</p></li>
</ul>
</p></li>
<li><p><strong>lin_layers</strong> (<em>int</em><em>, </em><em>default = 1</em>) – The number of linear regression layers. As of now, cannot be greater
than two (<strong>any value different than 1 will set it to two</strong>).</p></li>
<li><p><strong>lin_dropout</strong> (<em>float</em><em>, </em><em>optional</em>) – The value for the dropout layer that comes after the first linear layer
in the regression step. Will only be taken into accouunt if
<code class="docutils literal notranslate"><span class="pre">lin_layers</span></code> &gt; 1.</p></li>
</ul>
</dd>
<dt class="field-even">Raises</dt>
<dd class="field-even"><p><strong>AssertionError</strong> – If the version in different than 4 or 5;
    If an unsupported <code class="docutils literal notranslate"><span class="pre">pooling_layer</span></code> is informed.</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">torch.utils.data</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="o">*</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">delta</span> <span class="o">=</span> <span class="mi">10</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">hidden_dim</span> <span class="o">=</span> <span class="mi">20</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">version</span> <span class="o">=</span> <span class="mi">4</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">model</span> <span class="o">=</span> <span class="n">LSTM_v4</span><span class="p">(</span><span class="n">delta</span><span class="p">,</span> <span class="n">hidden_dim</span><span class="p">,</span> <span class="n">pooling_layer</span><span class="o">=</span><span class="s1">&#39;last&#39;</span><span class="p">,</span> <span class="n">version</span><span class="o">=</span><span class="n">version</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">([</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">version</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">)</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">estimated_capacity</span> <span class="o">=</span> <span class="n">model</span><span class="p">(</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">inputs</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss_function</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">nn</span><span class="o">.</span><span class="n">MSELoss</span><span class="p">()</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">loss</span> <span class="o">=</span> <span class="n">loss_function</span><span class="p">(</span><span class="n">estimated_capacity</span><span class="p">,</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">output</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
<span class="go">2.2862</span>
</pre></div>
</div>
<dl class="py method">
<dt class="sig sig-object py" id="LSTM.LSTM_v4.forward">
<span class="sig-name descname"><span class="pre">forward</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">inputs</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/LSTM.html#LSTM_v4.forward"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM.LSTM_v4.forward" title="Permalink to this definition">¶</a></dt>
<dd><p>Defines the computation performed at every call.</p>
<p>Should be overridden by all subclasses.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>Although the recipe for forward pass needs to be defined within
this function, one should call the <code class="xref py py-class docutils literal notranslate"><span class="pre">Module</span></code> instance afterwards
instead of this since the former takes care of running the
registered hooks while the latter silently ignores them.</p>
</div>
</dd></dl>

</dd></dl>

</div>
<div class="section" id="dataset-class">
<span id="normal-lstm-dataset"></span><h2>Dataset class<a class="headerlink" href="#dataset-class" title="Permalink to this headline">¶</a></h2>
<p>The datasets created by this class’ initialization follow You et al.’s
snapshot approach: I, V data for a charge cycle are used for battery
capacity prediction. A number <code class="docutils literal notranslate"><span class="pre">delta</span></code> of sequential <img class="math" src="_images/math/a90a6470949bc073dc4eae62a2b19937483cad4d.png" alt="(I, V)"/> points
(or <img class="math" src="_images/math/66771c6888d48156e8702be2685f41a5cf6349e3.png" alt="(I, V, T)"/>, depending on the model) are collected and turned into
a 1D vector <img class="math" src="_images/math/c67734af70861b2bd4dedf5c41c9aad231466f84.png" alt="x_i"/>. This window of points slides through time and each
vector <img class="math" src="_images/math/c67734af70861b2bd4dedf5c41c9aad231466f84.png" alt="x_i"/> becomes the sequential inputs of an LSTM.
Here, these <img class="math" src="_images/math/c67734af70861b2bd4dedf5c41c9aad231466f84.png" alt="x_i"/> vectors are made and grouped sequentially in a 2D
tensor called <code class="docutils literal notranslate"><span class="pre">XT</span></code>. One <code class="docutils literal notranslate"><span class="pre">XT</span></code> tensor = one sequence = one charge cycle =
one capacity value.
A list of all <code class="docutils literal notranslate"><span class="pre">XT</span></code> s is saved as attribute <code class="docutils literal notranslate"><span class="pre">inputs</span></code>.</p>
<p>The output for each <code class="docutils literal notranslate"><span class="pre">XT</span></code> (each charge cycle) is a capacity value (in A.h) or
the SOH (dimensionless) if parameter <code class="docutils literal notranslate"><span class="pre">adimensionalize</span> <span class="pre">=</span> <span class="pre">True</span></code>.
However, capacity values are only measured during discharge cycles. Because
of this, <strong>the capacity values taken as outputs are picked from the
discharge cycle that comes immediately before the charge cycle - this step must
be done during the creation of the cleaned dataset. See</strong>
<span class="xref std std-doc">Battery Classes</span> <strong>for more information</strong>.</p>
<p>If <code class="docutils literal notranslate"><span class="pre">norm</span></code> variable is initialized as <code class="docutils literal notranslate"><span class="pre">None</span></code> (default), the dataset will be
automatically normalised according to the given <code class="docutils literal notranslate"><span class="pre">norm_type</span></code> (<code class="docutils literal notranslate"><span class="pre">'zscore'</span></code> by
default), and the calculated normalisation parameters will be stored as
attribute <code class="docutils literal notranslate"><span class="pre">norm</span></code>. Alternatively, the user can inform a <code class="docutils literal notranslate"><span class="pre">norm</span></code> to be used.</p>
<dl class="py class">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM">
<em class="property"><span class="pre">class</span> </em><span class="sig-prename descclassname"><span class="pre">LSTM.</span></span><span class="sig-name descname"><span class="pre">Torch_Dataset_LSTM</span></span><span class="sig-paren">(</span><em class="sig-param"><span class="n"><span class="pre">Battery_list</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">delta</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">model_version</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">print_bool</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">False</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">time_step</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">threshold</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">0.1</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">min_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">150</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">fixed_len</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">150</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm_type</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">'zscore'</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">norm</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">None</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">adimensionalize</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">True</span></span></em>, <em class="sig-param"><span class="n"><span class="pre">cycle_lim</span></span><span class="o"><span class="pre">=</span></span><span class="default_value"><span class="pre">1000000.0</span></span></em><span class="sig-paren">)</span><a class="reference internal" href="_modules/LSTM.html#Torch_Dataset_LSTM"><span class="viewcode-link"><span class="pre">[source]</span></span></a><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM" title="Permalink to this definition">¶</a></dt>
<dd><p>Creates a Dataset class that can readily be loaded through a DataLoader
class for training and validation.</p>
<div class="admonition note">
<p class="admonition-title">Note</p>
<p>This class can only take in one type of dataset at a time.</p>
</div>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>Battery_list</strong> (<em>list</em><em>[</em><em>clean_battery_like</em><em>]</em>) – List with the Batteries that we want to use for creating the dataset.
Must be a clean battery class, such as
<a class="reference internal" href="sphinx/NASA.html#Nasa_Classes.Clean_Battery" title="Nasa_Classes.Clean_Battery"><code class="xref py py-class docutils literal notranslate"><span class="pre">Clean_Battery</span></code></a>,
<a class="reference internal" href="sphinx/MIT.html#MIT_Classes.Clean_MIT_Battery" title="MIT_Classes.Clean_MIT_Battery"><code class="xref py py-class docutils literal notranslate"><span class="pre">Clean_MIT_Battery</span></code></a> or
<a class="reference internal" href="sphinx/COIN.html#Coin_Classes.Clean_Coin_Battery" title="Coin_Classes.Clean_Coin_Battery"><code class="xref py py-class docutils literal notranslate"><span class="pre">Clean_Coin_Battery</span></code></a>.</p></li>
<li><p><strong>delta</strong> (<em>int</em>) – The size of the sliding window used to generate the <img class="math" src="_images/math/c67734af70861b2bd4dedf5c41c9aad231466f84.png" alt="x_i"/> s.</p></li>
<li><p><strong>model_version</strong> (<em>{1</em><em>, </em><em>2</em><em>, </em><em>3</em><em>, </em><em>4</em><em>, </em><em>5}</em>) – <p>An integer indicating the LSTM version.</p>
<ul>
<li><p><code class="docutils literal notranslate"><span class="pre">model_version</span> <span class="pre">=</span> <span class="pre">1</span></code>: then only I and V data will be used.</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">model_version</span> <span class="pre">=</span> <span class="pre">2</span></code>: then I, V and T will be taken into account.</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">model_version</span> <span class="pre">=</span> <span class="pre">3</span></code>: then I, V and ambient T will be taken into</p></li>
</ul>
<p>account.</p>
<ul>
<li><p><code class="docutils literal notranslate"><span class="pre">model_version</span> <span class="pre">=</span> <span class="pre">4</span></code>: then I, V and ambient T will be taken into</p></li>
</ul>
<p>account, but the ambient T will enter directly in the last step, the NN.</p>
<ul>
<li><p><code class="docutils literal notranslate"><span class="pre">model_version</span> <span class="pre">=</span> <span class="pre">5</span></code>: then I, V, T and amb_T will be taken into</p></li>
</ul>
<p>account, mixing models 2 and 4. Redundant.</p>
</p></li>
<li><p><strong>print_bool</strong> (<em>bool</em><em>, </em><em>default = False</em>) – Whether or not to print some information while the code runs.
Namely, if we want to print the battery’s name and the total number of
valid points in the dataset.</p></li>
<li><p><strong>time_step</strong> (<em>float</em><em>, </em><em>optional</em>) – The desired time step for the resampling procedure.
If <code class="docutils literal notranslate"><span class="pre">None</span></code> is given, then a time step will be automatically generated
by the method <code class="xref py py-func docutils literal notranslate"><span class="pre">time_step_function()</span></code>.</p></li>
<li><p><strong>threshold</strong> (<em>float</em><em>, </em><em>default = 0.1</em>) – The minimum capacity value to be considered as relevant [A.h].</p></li>
<li><p><strong>min_len</strong> (<em>int</em><em>, </em><em>default = 10</em>) – <p>The minimum amount of points a charge cycle must have after resampling
to be considered as relevant.</p>
<p>This parameter may be overridden by the value of <code class="docutils literal notranslate"><span class="pre">fixed_len</span></code> and
<code class="docutils literal notranslate"><span class="pre">delta</span></code> (very probable). I wouldn’t bother about it.</p>
</p></li>
<li><p><strong>fixed_len</strong> (<em>int</em><em>, </em><em>default = 150</em>) – If different than <code class="docutils literal notranslate"><span class="pre">None</span></code>, then the input sequence
length will be truncated at <code class="docutils literal notranslate"><span class="pre">fixed_len</span></code> points. This will override
<code class="docutils literal notranslate"><span class="pre">min_len</span></code>.</p></li>
<li><p><strong>norm_type</strong> (<em>{'zscore'</em><em>, </em><em>'minmax'}</em><em>, </em><em>default = 'zscore'</em>) – A string indicating which kind of normalization to do.</p></li>
<li><p><strong>norm</strong> (<em>tuple</em><em>(</em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>Tensor</em><em>, </em><em>string</em><em>)</em><em>, </em><em>optional</em>) – <p>A tuple containing all of the information necessary for normalization.</p>
<p>If different than <code class="docutils literal notranslate"><span class="pre">None</span></code>, then <code class="docutils literal notranslate"><span class="pre">norm_type</span></code> will be overridden by
<code class="docutils literal notranslate"><span class="pre">norm[4]</span></code> and the given information will be used for the
normalization.</p>
</p></li>
<li><p><strong>adimensionalize</strong> (<em>bool</em><em>, </em><em>default = True</em>) – <p>Whether or not to make variables dimensionless before adding them to the
inputs and output lists.</p>
<ul>
<li><p>The Capacity (output) is normalized by the nominal capacity
(<code class="docutils literal notranslate"><span class="pre">Q_nominal</span></code>);</p></li>
<li><p>The Current is normalized by the C rate (<code class="docutils literal notranslate"><span class="pre">C_rate</span></code>) -
which is the current necessary for charging the battery in one hour
(theoretically);</p></li>
<li><p>The Voltage is normalized by the nominal voltage (<code class="docutils literal notranslate"><span class="pre">V_nominal</span></code>),
the voltage at the plateau in the CV part of the charge curve.</p></li>
</ul>
<p>The values of these parameters are defined inside of each battery class.</p>
</p></li>
<li><p><strong>cycle_lim</strong> (<em>int</em><em>, </em><em>optional</em>) – The greatest cycle number to take into account for the dataset creation.
Default equals <code class="docutils literal notranslate"><span class="pre">1e6</span></code> meaning that no cycles will be ignored.</p></li>
</ul>
</dd>
</dl>
<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.dataset_name">
<span class="sig-name descname"><span class="pre">dataset_name</span></span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.dataset_name" title="Permalink to this definition">¶</a></dt>
<dd><p>The name of the give clean battery class (“<code class="docutils literal notranslate"><span class="pre">Clean_MIT_Battery</span></code>”,
for instance).</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.batteries">
<span class="sig-name descname"><span class="pre">batteries</span></span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.batteries" title="Permalink to this definition">¶</a></dt>
<dd><p>A list with the file name of each of the batteries used.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[str]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.min_len">
<span class="sig-name descname"><span class="pre">min_len</span></span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.min_len" title="Permalink to this definition">¶</a></dt>
<dd><p>The final <code class="docutils literal notranslate"><span class="pre">min_len</span></code> value after overrides.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>int</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.time_step">
<span class="sig-name descname"><span class="pre">time_step</span></span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.time_step" title="Permalink to this definition">¶</a></dt>
<dd><p>The final time_step value decided.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>float</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.dataset_format">
<span class="sig-name descname"><span class="pre">dataset_format</span></span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.dataset_format" title="Permalink to this definition">¶</a></dt>
<dd><p>A string indicating the type of data format used: ‘You et al. [56]’.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>str</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.Battery_list">
<span class="sig-name descname"><span class="pre">Battery_list</span></span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.Battery_list" title="Permalink to this definition">¶</a></dt>
<dd><p>A list with the clean batteries used for dataset creations. This is the
same as the <code class="docutils literal notranslate"><span class="pre">Battery_list</span></code> input for all datasets except for
Tarascon’s coin batteries. This is because the individual
<a class="reference internal" href="sphinx/COIN.html#Coin_Classes.Clean_Cell" title="Coin_Classes.Clean_Cell"><code class="xref py py-class docutils literal notranslate"><span class="pre">Clean_Cell</span></code></a> s are separated to be treated
individually. Check <span class="xref std std-doc">Tarascon’s Coin dataset</span>
documentation for more information on why.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[clean_battery_like]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.inputs">
<span class="sig-name descname"><span class="pre">inputs</span></span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.inputs" title="Permalink to this definition">¶</a></dt>
<dd><p>A list with the input tensors for each cycle.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>list[Tensors]</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.output">
<span class="sig-name descname"><span class="pre">output</span></span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.output" title="Permalink to this definition">¶</a></dt>
<dd><p>A tensor with the respective output capacity values for each cycle.
If <code class="docutils literal notranslate"><span class="pre">adimensionalize</span> <span class="pre">=</span> <span class="pre">True</span></code>, then values are dimensionless, and
capacity should be between 0 and 1. Otherwise, values should be in A.h.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>Tensor</p>
</dd>
</dl>
</dd></dl>

<dl class="py attribute">
<dt class="sig sig-object py" id="LSTM.Torch_Dataset_LSTM.norm">
<span class="sig-name descname"><span class="pre">norm</span></span><a class="headerlink" href="#LSTM.Torch_Dataset_LSTM.norm" title="Permalink to this definition">¶</a></dt>
<dd><p>A tuple containing all of the information necessary for normalization.</p>
<dl class="field-list simple">
<dt class="field-odd">Type</dt>
<dd class="field-odd"><p>tuple(Tensor, Tensor, Tensor, Tensor, string)</p>
</dd>
</dl>
</dd></dl>

<dl class="field-list simple">
<dt class="field-odd">Raises</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>AssertionError</strong> – If the specified value of <code class="docutils literal notranslate"><span class="pre">delta</span></code> is &lt; 1;
    If no batteries are given;
    If the specified version is invalid;
    If <code class="docutils literal notranslate"><span class="pre">model_version</span></code> is 2 or 5 and <code class="docutils literal notranslate"><span class="pre">self.dataset_name</span></code> is
    <code class="docutils literal notranslate"><span class="pre">Clean_Coin_Battery</span></code>.</p></li>
<li><p><strong>ValueError</strong> – If the <code class="docutils literal notranslate"><span class="pre">model_version</span></code> is unknown.</p></li>
</ul>
</dd>
</dl>
<p class="rubric">Examples</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">torch.utils.data</span> <span class="kn">import</span> <span class="n">Dataset</span>
<span class="gp">&gt;&gt;&gt; </span><span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="n">Torch_Dataset_LSTM</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">delta</span> <span class="o">=</span> <span class="mi">10</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">version</span> <span class="o">=</span> <span class="mi">2</span>
<span class="gp">&gt;&gt;&gt; </span><span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="s1">&#39;B0005.txt&#39;</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
<span class="gp">... </span>    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
<span class="gp">...</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">([</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">version</span><span class="p">,</span>
<span class="gp">... </span>                                   <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
<span class="go">B0005</span>
<span class="go">165</span>
</pre></div>
</div>
</dd></dl>

</div>
</div>


              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2022, Antonio ROCHA AZEVEDO.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>